<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>Akonadi.StandardActionManager</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>StandardActionManager Class Reference</h1>
<code>from PyKDE4.akonadi import *</code>
<p>
Inherits: <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a><br />

Namespace: Akonadi<br />
<h2>Detailed Description</h2>

<p>Manages generic actions for collection and item views.
</p>
<p>
Manages generic Akonadi actions common for all types. This covers
creating of the actions with appropriate labels, icons, shortcuts
etc., updating the action state depending on the current selection
as well as default implementations for the actual operations.
</p>
<p>
If the default implementation is not appropriate for your application
you can still use the state tracking by disconnecting the triggered()
signal and re-connecting it to your implementation. The actual KAction
objects can be retrieved by calling createAction() or action() for that.
</p>
<p>
If the default look and feel (labels, icons, shortcuts) of the actions
is not appropriate for your application, you can access them as noted
above and customize them to your needs. Additionally, you can set a
KLocalizedString which should be used as a action label with correct
plural handling for actions operating on multiple objects with
setActionText().
</p>
<p>
Finally, if you have special needs for the action states, connect to
the actionStateUpdated() signal and adjust the state accordingly.
</p>
<p>
The following actions are provided (KAction name in parenthesis):
- Creation of a new collection (@c akonadi_collection_create)
- Copying of selected collections (@c akonadi_collection_copy)
- Deletion of selected collections (@c akonadi_collection_delete)
- Synchronization of selected collections (@c akonadi_collection_sync)
- Showing the collection properties dialog for the current collection (@c akonadi_collection_properties)
- Copying of selected items (@c akonadi_itemcopy)
- Pasting collections, items or raw data (@c akonadi_paste)
- Deleting of selected items (@c akonadi_item_delete)
- Managing local subscriptions (@c akonadi_manage_local_subscriptions)
</p>
<p>
The following example shows how to use standard actions in your application:
</p>
<p>
<pre class="fragment">

 Akonadi.StandardActionManager *actMgr = new Akonadi.StandardActionManager( actionCollection(), this );
 actMgr-&gt;setCollectionSelectionModel( collectionView-&gt;collectionSelectionModel() );
 actMgr-&gt;createAllActions();

</pre>
</p>
<p>
Additionally you have to add the actions to the KXMLGUI file of your application,
using the names listed above.
</p>
<p>
If you only need a subset of the actions provided, you can call createAction()
instead of createAllActions() for the action types you want.
</p>
<p>
To do: collection deleting and sync do not support multi-selection yet
</p>
<p>

<dl class="author" compact><dt><b>Author:</b></dt><dd> Volker Krause &lt;vkrause@kde.org&gt; </dd></dl>
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="#obj202028844">Type</a>&nbsp;</td><td class="memItemRight" valign="bottom">{&nbsp;CreateCollection, CopyCollections, DeleteCollections, SynchronizeCollections, CollectionProperties, CopyItems, Paste, DeleteItems, ManageLocalSubscriptions, LastType&nbsp;}</td></tr>
<tr><td colspan="2"><br><h2>Signals</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj189072460">actionStateUpdated</a> ()</td></tr>
<tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj189815692">__init__</a> (self, <a href="../kdeui/KActionCollection.html">KActionCollection</a> actionCollection, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a> parent=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../kdeui/KAction.html">KAction</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj195381868">action</a> (self, Akonadi.StandardActionManager.Type type)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj189072460">actionStateUpdated</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../kdeui/KAction.html">KAction</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192729900">createAction</a> (self, Akonadi.StandardActionManager.Type type)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj172088076">createAllActions</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj183908108">setActionText</a> (self, Akonadi.StandardActionManager.Type type, <a href="../kdecore/KLocalizedString.html">KLocalizedString</a> text)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj196950668">setCollectionSelectionModel</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qitemselectionmodel.html">QItemSelectionModel</a> selectionModel)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj183091788">setItemSelectionModel</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qitemselectionmodel.html">QItemSelectionModel</a> selectionModel)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj189815692"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdeui/KActionCollection.html">KActionCollection</a>&nbsp;</td>
<td class="paramname"><em>actionCollection</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a>&nbsp;</td>
<td class="paramname"><em>parent=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Creates a new standard action manager.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>actionCollection</em>&nbsp;</td><td> The action collection to operate on.

<tr><td></td><td valign="top"><em>parent</em>&nbsp;</td><td> The parent widget.
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj195381868"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../kdeui/KAction.html">KAction</a> action</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Akonadi.StandardActionManager.Type&nbsp;</td>
<td class="paramname"><em>type</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Returns the action of the given type, 0 if it has not been created (yet).
</p></div></div><a class="anchor" name="obj189072460"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> actionStateUpdated</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>This signal is emitted whenever the action state has been updated.
In case you have special needs for changing the state of some actions,
connect to this signal and adjust the action state.
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("actionStateUpdated()"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj192729900"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../kdeui/KAction.html">KAction</a> createAction</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Akonadi.StandardActionManager.Type&nbsp;</td>
<td class="paramname"><em>type</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Creates the action of the given type and adds it to the action collection
specified in the constructor if it does not exist yet. The action is
connected to its default implementation provided by this class.
</p></div></div><a class="anchor" name="obj172088076"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> createAllActions</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Convenience method to create all standard actions.
<dl class="see" compact><dt><b>See also:</b></dt><dd> createAction()
</dd></dl>
</p></div></div><a class="anchor" name="obj183908108"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setActionText</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Akonadi.StandardActionManager.Type&nbsp;</td>
<td class="paramname"><em>type</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KLocalizedString.html">KLocalizedString</a>&nbsp;</td>
<td class="paramname"><em>text</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Sets the label of the action <b>type</b> to <b>text,</b> which is used during
updating the action state and substituted according to the number of
selected objects. This is mainly useful to customize the label of actions
that can operate on multiple objects.
</p>
<p>
Example:
<pre class="fragment">
 acctMgr-&gt;setActionText( Akonadi.StandardActionManager.CopyItems,
                         ki18np( "Copy Mail", "Copy %1 Mails" ) );
</pre>
</p></div></div><a class="anchor" name="obj196950668"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setCollectionSelectionModel</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qitemselectionmodel.html">QItemSelectionModel</a>&nbsp;</td>
<td class="paramname"><em>selectionModel</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Sets the collection selection model based on which the collection
related actions should operate. If none is set, all collection actions
will be disabled.
</p></div></div><a class="anchor" name="obj183091788"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setItemSelectionModel</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qitemselectionmodel.html">QItemSelectionModel</a>&nbsp;</td>
<td class="paramname"><em>selectionModel</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Sets the item selection model based on which the item related actions
should operate. If none is set, all item actions will be disabled.
</p></div></div><hr><h2>Enumeration Documentation</h2><a class="anchor" name="obj202028844"></a>
<div class="memitem">
<div class="memproto">
<table class="memname">
<tr><td class="memname">Type</td>
</tr>
</table>
</div>
<div class="memdoc"><p>Describes the supported actions.
</p><dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0"><tr><td valign="top"><em>CreateCollection</em>&nbsp;</td><td><tr><td valign="top"><em>CopyCollections</em>&nbsp;</td><td><tr><td valign="top"><em>DeleteCollections</em>&nbsp;</td><td><tr><td valign="top"><em>SynchronizeCollections</em>&nbsp;</td><td><tr><td valign="top"><em>CollectionProperties</em>&nbsp;</td><td><tr><td valign="top"><em>CopyItems</em>&nbsp;</td><td><tr><td valign="top"><em>Paste</em>&nbsp;</td><td><tr><td valign="top"><em>DeleteItems</em>&nbsp;</td><td><tr><td valign="top"><em>ManageLocalSubscriptions</em>&nbsp;</td><td><tr><td valign="top"><em>LastType</em>&nbsp;</td><td></table>
</dl>
</div></div><p>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
